
import { _decorator, Component, Node, systemEvent, SystemEvent, view } from 'cc';
const { ccclass, property } = _decorator;

/**
 * Predefined variables
 * Name = NewComponent
 * DateTime = Mon Oct 18 2021 17:04:21 GMT+0800 (中国标准时间)
 * Author = muxiandong
 * FileBasename = NewComponent.ts
 * FileBasenameNoExtension = NewComponent
 * URL = db://assets/NewComponent.ts
 * ManualUrl = https://docs.cocos.com/creator/3.3/manual/zh/
 *
 */
 
@ccclass('NewComponent')
export class NewComponent extends Component {
    // [1]
    // dummy = '';

    // [2]
    // @property
    // serializableDummy = 0;

    start () {
        // [3]

        systemEvent.on(SystemEvent.EventType.MOUSE_DOWN, this._mouseDown, this);
        systemEvent.on(SystemEvent.EventType.MOUSE_UP, this._mouseUp, this);
        systemEvent.on(SystemEvent.EventType.MOUSE_MOVE, this._mouseMove, this);
    }

    
    _mouseDown (evt) {
        console.log(evt);
    }

    _mouseUp (evt) {
        console.log(evt);
    }

    _mouseMove (evt) {
        let pos = evt.getUILocation();
        let winSize = view.getFrameSize();
        pos.x -= winSize.width / 2;
        pos.y -= winSize.height / 2;
        console.log(pos);
    }
}

/**
 * [1] Class member could be defined like this.
 * [2] Use `property` decorator if your want the member to be serializable.
 * [3] Your initialization goes here.
 * [4] Your update function goes here.
 *
 * Learn more about scripting: https://docs.cocos.com/creator/3.3/manual/zh/scripting/
 * Learn more about CCClass: https://docs.cocos.com/creator/3.3/manual/zh/scripting/ccclass.html
 * Learn more about life-cycle callbacks: https://docs.cocos.com/creator/3.3/manual/zh/scripting/life-cycle-callbacks.html
 */
